<?php

/**
 * plugins/fortune_jp/setup.php
 *
 * Copyright (c) 1999-2004 The SquirrelMail-JP Project Team
 * Licensed under the GNU GPL. For full terms see the file COPYING.
 *
 * Original code contributed by sawada_k@na.rim.or.jp
 *
 * Simple SquirrelMail WebMail Plugin that displays the output of
 * fortune_jp above the message listing.
 *
 * $Id: setup.php,v 1.5 2004/02/01 00:00:00 Exp $
 */

function squirrelmail_plugin_init_fortune_jp() {
  global $squirrelmail_plugin_hooks;
  
  $squirrelmail_plugin_hooks['mailbox_index_before']['fortune_jp'] = 'fortune';
  $squirrelmail_plugin_hooks['options_display_inside']['fortune_jp'] = 'fortune_options';
  $squirrelmail_plugin_hooks['options_display_save']['fortune_jp'] = 'fortune_save';
  $squirrelmail_plugin_hooks['loading_prefs']['fortune_jp'] = 'fortune_load';  
}

function fortune() {
  global $fortune_visible, $knowledge_visible, $newton_visible, $color;
  global $prefs_dsn ;

  require_once('DB.php');

  if ( isset($prefs_dsn) && $prefs_dsn!="" ) {
    $dsn = $prefs_dsn ;
  } else {
    // edit from here 
    $dsn = 'pgsql://dbuser:passwd@host_name/dbname';
    // edit to end
  }

  $dbh = DB::connect($dsn);
  if(DB::isError($dbh)) { $error = DB::errorMessage($dbh); return; }
  list($usec, $sec) = explode(' ', microtime()) ;
  srand( (float)$sec + ( (float)$usec*100000 ) ) ;

  if ( $fortune_visible ) {
    $table = 'sq_fortune' ;
    $total = $dbh->getOne("SELECT count(serial) FROM $table") ;

    echo "<center>" .
         "<table WIDTH=\"90%\" cellpadding=2 cellspacing=1 border=0 bgcolor=\"$color[5]\">" .
         "<tr><td align=center>";
    echo    "<FONT SIZE=\"-2\">--- <EM>γʸ̾</EM> ---</FONT><BR>
             <FONT SIZE=\"-1\">";

     $num = rand ( 1, $total ) ;
     $query = "SELECT fortune,genre,count FROM $table WHERE serial=$num" ;
     $res = $dbh->query($query);
     $row = $res->fetchRow(DB_FETCHMODE_ORDERED);
     $count = $row[2]+1 ;
     $query = "UPDATE $table SET count = $count WHERE serial = $num " ;

         $dbh->simpleQuery("BEGIN TRANSACTION");
         $res = $dbh->simpleQuery($query);
         if (DB::isError($res)) {
           $dbh->simpleQuery("ROLLBACK TRANSACTION");
         }
         $dbh->simpleQuery("COMMIT TRANSACTION");

     echo $row[0];
     echo "&nbsp;&nbsp;&nbsp;&nbsp;</FONT><FONT SIZE=1>--&nbsp;&nbsp;
           <A HREF=\"http://kuroneko22.cool.ne.jp/index.htm\" TARGET=\"_blank\">
           ʸ</A>[" . $row[1] . "]($num/$total:$count)</FONT>
             </TD>
          </TR></TABLE></center>";
  }

  if ( $knowledge_visible ) {
    $table = 'sq_knowledge' ;
    $total = $dbh->getOne("SELECT count(serial) FROM $table") ;

    echo "<center>" .
         "<table WIDTH=\"90%\" cellpadding=2 cellspacing=1 border=0 bgcolor=\"$color[5]\">" .
         "<tr><td align=center>";
    echo    "<FONT SIZE=\"-2\">--- <EM>Ʀμ</EM> ---</FONT><BR>
             <FONT SIZE=\"-1\">";

     $num = rand ( 1, $total ) ;
     $query = "SELECT fortune,genre,count FROM $table WHERE serial=$num" ;
     $res = $dbh->query($query);
     $row = $res->fetchRow(DB_FETCHMODE_ORDERED);
     $count = $row[2]+1 ;
     $query = "UPDATE $table SET count = $count WHERE serial = $num " ;

         $dbh->simpleQuery("BEGIN TRANSACTION");
         $res = $dbh->simpleQuery($query);
         if (DB::isError($res)) {
           $dbh->simpleQuery("ROLLBACK TRANSACTION");
         }
         $dbh->simpleQuery("COMMIT TRANSACTION");

     echo $row[0];
     echo "</FONT><BR><FONT SIZE=1>--&nbsp;&nbsp;
           <A HREF=\"http://kuroneko22.cool.ne.jp/index.htm\" TARGET=\"_blank\">
           ʸ</A>[" . $row[1] . "]($num/$total:$count)</FONT>
             </TD>
          </TR></TABLE></center>";
  }

  return;
}

function fortune_load() {
    global $username, $data_dir, $fortune_visible,
           $knowledge_visible, $newton_visible ;

    $fortune_visible   = getPref($data_dir, $username, 'fortune_visible'  );
    $knowledge_visible = getPref($data_dir, $username, 'knowledge_visible');

}

function fortune_options() {
  global $fortune_visible, $knowledge_visible, $newton_visible ;

  echo "<tr><td COLSPAN=2>&nbsp;</td></tr>" ;
  echo "<tr><td ALIGN=CENTER VALIGN=MIDDLE COLSPAN=2 NOWRAP><b>" .
       "᡼BOX˳ʸƦμɽ" .
       "</b></td></tr>" ;

  echo "<tr><td align=right nowrap><FONT SIZE=-2>" .
       "ʸɽ[No./:ɽ]"   . "</FONT></td>\n";
  echo '<td><input name="fortune_fortune_visible" type=CHECKBOX';
  if ($fortune_visible)  echo ' CHECKED';
  echo "> <FONT SIZE=-2>" . "᡼BOX˳ʸ̾ɽ" .
       "</FONT></td></tr>\n";

  echo "<tr><td align=right nowrap><FONT SIZE=-2>" .
       "Ʀμɽ[No./:ɽ]"  . "</FONT></td>\n";
  echo '<td><input name="fortune_knowledge_visible" type=CHECKBOX';
  if ($knowledge_visible)  echo ' CHECKED';
  echo "> <FONT SIZE=-2>" . "᡼BOXƦμɽ" .
       "</FONT></td></tr>\n";

}

function fortune_save() {
    global $username,$data_dir;

    if (isset($_POST['fortune_fortune_visible'])) {
        setPref($data_dir, $username, 'fortune_visible', '1');
    } else {
        setPref($data_dir, $username, 'fortune_visible', '');
    }

    if (isset($_POST['fortune_knowledge_visible'])) {
        setPref($data_dir, $username, 'knowledge_visible', '1');
    } else {
        setPref($data_dir, $username, 'knowledge_visible', '');
    }
}

?>
